#include "mouseapiexample.h"
#include "gametypes/Gametype.h"
#include "infos/PlayerInfo.h"
#include "worldentities/CameraPosition.h"
#include "worldentities/ControllableEntity.h"

namespace orxonox
{

RegisterClass(MouseAPIExample);

MouseAPIExample::MouseAPIExample(Context* context) : ControllableEntity(context)
{
    RegisterObject(MouseAPIExample);
}

MouseAPIExample::~MouseAPIExample()
{
    if(MouseAPI::isActive())
        MouseAPI::getInstance().deactivate();
}

// change the size of the cube to a random number by clicking on it
void MouseAPIExample::changesizeonclick(MouseButtonCode::ByEnum mouse)
{
    // generate random number between 1 and 20
    float randomnumber = std::fmax((rand()%100 + 1)/20.0,1);
    // change the scale of the cube to this random number
    this->setScale(randomnumber);
    // change the radius of the clickableObject to the new size
    MouseAPI::getInstance().changeRadiusOfClickableObject(cubeid,randomnumber);
}

// change the size of the sphere by scrolling on it
void MouseAPIExample::changesizeonscroll(int abs,int rel,const IntVector2& mousePos)
{
    // increase or decrease the size of the sphere
    this->setScale(1+rel);
}

void MouseAPIExample::XMLPort(Element& xmlelement, XMLPort::Mode mode)
{
    SUPER(MouseAPIExample, XMLPort, xmlelement, mode);
    //todo: id xml-port
    MouseAPI::getInstance().activate();
    cubeid = MouseAPI::getInstance().addClickableObject(this->getWorldPosition(),10,std::list<MouseButtonCode::ByEnum>{MouseButtonCode::Left},[this](MouseButtonCode::ByEnum mouse){this->changesizeonclick(mouse);});
    //sphereid = MouseAPI::addScrollElement(this->getWorldPosition(), 10, [this](int abs, int rel, const IntVector2& mousePos){this->changesizeonscroll(abs,rel,mousePos);});

}
}
